unit BWCol;

{ *************************************************************************** }
{  Colours converter - convert #RRGGBB colour to its corresponding grayscale  }
{  Marian Stach, (C) 2003-06-28, Freeware                                     }
{ *************************************************************************** }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    HEXC: TEdit;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Edit4: TEdit;
    Button1: TButton;
    CheckBox1: TCheckBox;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function Hex2Byte(S: string): Byte;
  var
    Temp: Byte;
    Err: Integer;
  begin
    Insert('$',S,1);
    Val(S, Temp, Err);
    Hex2Byte := Temp;
  end;

function GreyWebSafe (A : Integer) : Integer;
  begin
    GreyWebSafe := Round (A / $33) * $33;
  end;

procedure TForm1.Button1Click(Sender: TObject);
  var RStr, GStr, BStr, TStr : string;
      R, G, B, CR, CB : Byte;
      K, K100, RG, GG, BG, RGW, GGW, BGW : Integer;
begin
  TStr := HexC.Text;
  if TStr[1] = '#' then Delete (TStr, 1, 1);
  RStr := Copy (TStr, 1, 2);
  GStr := Copy (TStr, 3, 2);
  BStr := Copy (TStr, 5, 2);
  R := Hex2Byte (RStr);
  G := Hex2Byte (GStr);
  B := Hex2Byte (BStr);

  K := Round (0.299*R + 0.587*G + 0.114*B);
  K100 := Trunc (100/256 * K);
  CR := 128;
  CB := 128;

  RG := Trunc (K +1.402 * (CR - 128));
  GG := Trunc (K - 0.34414 * (CB - 128) - 0.71414 * (CR - 128));
  BG := Trunc (K + 1.772 * (CB - 128));

  RGW := GreyWebSafe (RG);
  GGW := GreyWebSafe (GG);
  BGW := GreyWebSafe (BG);

  Edit2.Text := IntToStr (K100);

  TStr := IntToHex (RG, 2) + IntToHex (GG, 2) + IntToHex (BG, 2);
  if CheckBox1.Checked then TStr := '#' + TStr;
  Edit3.Text := TStr;

  TStr := IntToHex (RGW, 2) + IntToHex (GGW, 2) + IntToHex (BGW, 2);
  if CheckBox1.Checked then TStr := '#' + TStr;
  Edit4.Text := TStr;
end;

end.
